<?php
$subway_options   = subway_qode_return_global_options();
$qode_page_id     = subway_qode_get_page_id();

if ( get_post_meta( $qode_page_id, "qode_responsive-title-image", true ) != "" ) {
    $responsive_title_image = get_post_meta( $qode_page_id, "qode_responsive-title-image", true );
} else {
    $responsive_title_image = $subway_options['responsive_title_image'];
}

if ( get_post_meta( $qode_page_id, "qode_fixed-title-image", true ) != "" ) {
    $fixed_title_image = get_post_meta( $qode_page_id, "qode_fixed-title-image", true );
} else {
    $fixed_title_image = $subway_options['fixed_title_image'];
}

if ( get_post_meta( $qode_page_id, "qode_title-image", true ) != "" ) {
    $title_image = get_post_meta( $qode_page_id, "qode_title-image", true );
} else {
    $title_image = $subway_options['title_image'];
}

if ( get_post_meta( $qode_page_id, "qode_title-height", true ) != "" ) {
    $title_height = get_post_meta( $qode_page_id, "qode_title-height", true );
} else {
    $title_height = $subway_options['title_height'];
}

$title_background_color = '';
if ( get_post_meta( $qode_page_id, "qode_page-title-background-color", true ) != "" ) {
    $title_background_color = get_post_meta( $qode_page_id, "qode_page-title-background-color", true );
} else {
    $title_background_color = $subway_options['title_background_color'];
}

$show_title_image = true;
if ( get_post_meta( $qode_page_id, "qode_show-page-title-image", true ) ) {
    $show_title_image = false;
}

$title_classes = array();

if ( $responsive_title_image == 'no' && $title_image != "" && $fixed_title_image == "yes" && $show_title_image == true ) {
    $title_classes[] = 'has_fixed_background';
}

if ( $responsive_title_image == 'no' && $title_image != "" && $fixed_title_image == "no" && $show_title_image == true ) {
    $title_classes[] = 'has_background';
}

if ( $responsive_title_image == 'yes' && $show_title_image == true ) {
    $title_classes[] = 'with_image';
}

$title             = get_the_title( $qode_page_id );
$enable_page_title = get_post_meta( $qode_page_id, "qode_page-title-text", true );
if ( is_home() && is_front_page() ) {
    $title = get_option( 'blogname' );
} elseif ( is_tag() ) {
    $title = single_term_title( '', false ) . esc_html__( ' Tag', 'subway' );
} elseif ( is_date() ) {
    $title = get_the_time( 'F Y' );
} elseif ( is_author() ) {
    $title = esc_html__( 'Author: ', 'subway' ) . get_the_author();
} elseif ( is_category() ) {
    $title = single_cat_title( '', false );
} elseif ( is_archive() ) {
    $title = esc_html__( 'Archive', 'subway' );
} elseif ( is_search() ) {
    $title = esc_html__( 'Search: ', 'subway' ) . get_search_query();
} elseif ( is_404() ) {
    $title = $subway_options['404_title'] !== '' ? $subway_options['404_title'] : esc_html__( '404', 'subway' );
} elseif ( is_singular( 'post' ) && empty( $enable_page_title ) ) {
    $title = esc_html__( 'Blog', 'subway' );
}

if ( subway_qode_is_woocommerce_shop() || is_singular( 'product' ) ) {
    $shop_id = subway_qode_get_woo_shop_page_id();
    $title   = ! empty( $shop_id ) ? get_the_title( $shop_id ) : esc_html__( 'Shop', 'subway' );
} elseif ( ( function_exists( 'is_product_category' ) && is_product_category() ) || ( function_exists( 'is_product_tag' ) && is_product_tag() ) ) {
    $tax = get_queried_object();

    if ( ! empty( $tax ) ) {
        $title = $tax->name ;
    }
}

$title_styles = array();
if ( $responsive_title_image == 'no' && $title_image != "" && $show_title_image == true ) {
    $title_styles[] = 'background-image:url(' . esc_url( $title_image ) . ');';
}

if ( $responsive_title_image == 'no' && $title_height != '' ) {
    $title_styles[] = 'height:' . intval( $title_height ) . 'px;';
}

if ( $title_background_color != '' ) {
    $title_styles[] = 'background-color:' . $title_background_color . ';';
}

$title_label_styles = array();
if ( get_post_meta( $qode_page_id, "qode_page-title-color", true ) != "" ) {
    $title_label_styles[] = 'color: ' . get_post_meta( $qode_page_id, "qode_page-title-color", true );
}

$subtitle_text = get_post_meta( $qode_page_id, "qode_page_subtitle", true );
if ( is_404() ) {
    if ( isset( $subway_options['404_subtitle'] ) && $subway_options['404_subtitle'] != "" ) {
        $subtitle_text = $subway_options['404_subtitle'];
    } else {
        $subtitle_text = esc_html__( 'Page not found', 'subway' );
    }
}

$subtitle_styles = array();
if ( get_post_meta( $qode_page_id, "qode_page_subtitle_color", true ) != "" ) {
    $subtitle_styles[] = 'color: ' . get_post_meta( $qode_page_id, "qode_page_subtitle_color", true );
}

if ( ! get_post_meta( $qode_page_id, "qode_show-page-title", true ) ) { ?>
    <div class="title <?php echo esc_attr( implode( ' ', $title_classes ) ); ?>" <?php subway_qode_inline_style( $title_styles ); ?>>
        <?php if ( $responsive_title_image == 'yes' && ! empty( $title_image ) && $show_title_image == true ) { ?>
            <img src="<?php echo esc_url( $title_image ); ?>" alt="<?php esc_attr_e( 'Title Image', 'subway' ); ?>" />
        <?php } ?>
        <?php if(!get_post_meta($qode_page_id, "qode_show-page-title-text", true)) { ?>
            <div class="title_holder">
                <div class="container">
                    <div class="container_inner clearfix">
                        <h1 <?php subway_qode_inline_style( $title_label_styles ); ?>><?php echo wp_kses_post( $title ); ?></h1>
                        <?php if (function_exists('subway_qode_custom_breadcrumbs')) { ?> <div class="breadcrumb"> <?php subway_qode_custom_breadcrumbs(); ?></div><?php } ?>
                    </div>
                </div>
            </div>
        <?php } ?>
    </div>
<?php } ?>